﻿/// <reference path="../../../Resources/TypeDefinitions/knockout/knockout.d.ts"/>
/// <reference path="../../../Resources/TypeDefinitions/jquery/jquery.d.ts"/>
/// <reference path="../../../rubbish.ts"/>

var BowerPackageSummaryViewModel = (function () {
    function BowerPackageSummaryViewModel(data, feedName) {
        var _this = this;
        this.name = data.name;
        this.hits = data.hits;
        this.isLocal = data.isLocal;

        this.url = ko.computed(function () {
            return '/bower-feeds/' + encodeURIComponent(feedName) + '/' + encodeURIComponent(_this.name);
        });
    }
    return BowerPackageSummaryViewModel;
})();

var BrowseBowerFeedPageViewModel = (function () {
    function BrowseBowerFeedPageViewModel(data) {
        var _this = this;
        this.updateUrl = data.updateUrl;
        this.feedId = data.feedId;
        this.feedName = data.feedName;
        this.searchTerm = ko.observable('');
        this.maxResults = ko.observable(20);
        this.packages = ko.observableArray();
        this.isLoading = ko.observable(true);

        this.update();

        this.searchTerm.subscribe(function (v) {
            return _this.update();
        });
        this.maxResults.subscribe(function (v) {
            return _this.update();
        });

        $('form').submit(function () {
            _this.searchTerm($('.package-search > input').val());
            return false;
        });
    }
    BrowseBowerFeedPageViewModel.prototype.update = function () {
        var _this = this;
        this.isLoading(true);
        this.packages.removeAll();
        $.ajax({
            url: this.updateUrl,
            data: { feedId: this.feedId, searchTerm: this.searchTerm(), maxResults: this.maxResults() },
            type: 'POST',
            success: function (result) {
                _this.packages.removeAll();
                for (var i = 0; i < result.length; i++) {
                    _this.packages.push(new BowerPackageSummaryViewModel(result[i], _this.feedName));
                }

                _this.isLoading(false);
            }
        });
    };
    return BrowseBowerFeedPageViewModel;
})();
