﻿/// <reference path="../../../Resources/TypeDefinitions/knockout/knockout.d.ts"/>
/// <reference path="../../../Resources/TypeDefinitions/jquery/jquery.d.ts"/>
/// <reference path="../../../Resources/TypeDefinitions/inedojq/inedojq_frameddialog.d.ts"/>
/// <reference path="../../../rubbish.ts"/>

var MavenPackageVersionPageViewModel = (function () {
    function MavenPackageVersionPageViewModel(data) {
        var _this = this;
        this.loading = ko.observable(true);
        this.details = ko.observable();
        this.feedId = data.feedId;
        this.feedName = data.feedName;
        this.groupId = data.groupId;
        this.artifactId = data.artifactId;
        this.version = data.version;

        this.displayName = ko.computed(function () {
            return (_this.details() ? _this.details().name : null) || _this.artifactId;
        });

        this.isLocal = ko.computed(function () {
            return _this.details() ? _this.details().isLocal : false;
        });

        this.allVersions = ko.computed(function () {
            var details = _this.details();
            if (details) {
                return details.allVersions.map(function (v) {
                    return {
                        text: v,
                        url: '/maven-feeds/' + encodeURIComponent(_this.feedName) + '/' + encodeURIComponent(_this.groupId).replace(/\./g, '/') + '/' + encodeURIComponent(_this.artifactId) + '/' + encodeURIComponent(v),
                        current: v == _this.version
                    };
                });
            } else {
                return [
                    {
                        text: _this.version,
                        url: window.location.href,
                        current: true
                    }
                ];
            }
        });

        $.ajax({
            url: data.getInfoUrl,
            data: { feedId: this.feedId, groupId: this.groupId, artifactId: this.artifactId, version: this.version },
            type: 'POST',
            success: function (detailsData) {
                _this.details(detailsData);
            },
            complete: function () {
                _this.loading(false);
            }
        });
    }
    MavenPackageVersionPageViewModel.prototype.deleteClick = function () {
        $.inedojq_frameddialog(this.details().deleteUrl);
    };

    MavenPackageVersionPageViewModel.prototype.pullClick = function () {
        $.inedojq_frameddialog(this.details().pullUrl);
    };
    return MavenPackageVersionPageViewModel;
})();
